Ruby: ext/digest/sha2/sha2init.c File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Macros | Functions
sha2init.c File Reference
`#include <ruby/ruby.h>`
`#include "../digest.h"`
`#include "sha2.h"`

Go to the source code of this file.

## Macros
#define | FOREACH_BITLEN(func) func(256) func(384) func(512)
#define | DEFINE_ALGO_METADATA(bitlen)
#define | DECLARE_ALGO_CLASS(bitlen) VALUE cDigest_SHA##bitlen;
#define | DEFINE_ALGO_CLASS(bitlen)

## Functions
void | Init_sha2 (void)

## Macro Definition Documentation

## ◆ DECLARE_ALGO_CLASS

#define DECLARE_ALGO_CLASS | ( |  | bitlen | ) | VALUE cDigest_SHA##bitlen;

## ◆ DEFINE_ALGO_CLASS

#define DEFINE_ALGO_CLASS | ( |  | bitlen | ) |

Value:
cDigest_SHA##bitlen = rb_define_class_under(mDigest, "SHA" #bitlen, cDigest_Base); \
\
rb_ivar_set(cDigest_SHA##bitlen, id_metadata, \
rb_digest_make_metadata(&sha##bitlen));
rb_define_class_under
VALUE rb_define_class_under(VALUE outer, const char *name, VALUE super)
Defines a class under the namespace of outer.
Definition: class.c:797

## ◆ DEFINE_ALGO_METADATA

#define DEFINE_ALGO_METADATA | ( |  | bitlen | ) |

Value:
static const rb_digest_metadata_t sha##bitlen = { \
RUBY_DIGEST_API_VERSION, \
SHA##bitlen##_DIGEST_LENGTH, \
SHA##bitlen##_BLOCK_LENGTH, \
sizeof(SHA##bitlen##_CTX), \
(rb_digest_hash_init_func_t)SHA##bitlen##_Init, \
(rb_digest_hash_update_func_t)SHA##bitlen##_Update, \
(rb_digest_hash_finish_func_t)SHA##bitlen##_Finish, \
};
RUBY_DIGEST_API_VERSION
#define RUBY_DIGEST_API_VERSION
Definition: digest.h:18
rb_digest_hash_update_func_t
void(* rb_digest_hash_update_func_t)(void *, unsigned char *, size_t)
Definition: digest.h:21
rb_digest_hash_init_func_t
int(* rb_digest_hash_init_func_t)(void *)
Definition: digest.h:20
rb_digest_hash_finish_func_t
int(* rb_digest_hash_finish_func_t)(void *, unsigned char *)
Definition: digest.h:22
rb_digest_metadata_t
Definition: digest.h:24

Definition at line 14 of file sha2init.c.

## ◆ FOREACH_BITLEN

#define FOREACH_BITLEN | ( |  | func | ) | func(256) func(384) func(512)

Definition at line 12 of file sha2init.c.

## Function Documentation

## ◆ Init_sha2()

void Init_sha2 | ( | void |  | ) |

Definition at line 33 of file sha2init.c.

References DECLARE_ALGO_CLASS, DEFINE_ALGO_CLASS, FOREACH_BITLEN, and rb_path2class().